---
title: CanvasRenderingContext2D.quadraticCurveTo()
slug: Web/API/CanvasRenderingContext2D/quadraticCurveTo
tags:
  - API
  - Canvas
  - CanvasRenderingContext2D
  - Method
  - Reference
---
<div>{{APIRef}}</div>

<p>The <code><strong>CanvasRenderingContext2D</strong></code><strong><code>.quadraticCurveTo()</code></strong> method of the Canvas 2D API adds a quadratic <a href="https://en.wikipedia.org/wiki/B%C3%A9zier_curve">Bézier curve</a> to the current sub-path. It requires two points: the first one is a control point and the second one is the end point. The starting point is the latest point in the current path, which can be changed using {{domxref("CanvasRenderingContext2D.moveTo", "moveTo()")}} before creating the quadratic Bézier curve.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">void <em>ctx</em>.quadraticCurveTo(<em>cpx</em>, <em>cpy</em>, <em>x</em>, <em>y</em>);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>cpx</code></dt>
 <dd>The x-axis coordinate of the control point.</dd>
 <dt><code>cpy</code></dt>
 <dd>The y-axis coordinate of the control point.</dd>
 <dt><code>x</code></dt>
 <dd>The x-axis coordinate of the end point.</dd>
 <dt><code>y</code></dt>
 <dd>The y-axis coordinate of the end point.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<h3 id="How_quadraticCurveTo_works">How quadraticCurveTo works</h3>

<p>This example shows how a quadratic Bézier curve is drawn.</p>

<h4 id="HTML">HTML</h4>

<pre class="brush: html">&lt;canvas id="canvas"&gt;&lt;/canvas&gt;
</pre>

<h4 id="JavaScript">JavaScript</h4>

<pre class="brush: js; highlight:[7]">const canvas = document.getElementById('canvas');
const ctx = canvas.getContext('2d');

// Quadratic Bézier curve
ctx.beginPath();
ctx.moveTo(50, 20);
ctx.quadraticCurveTo(230, 30, 50, 100);
ctx.stroke();

// Start and end points
ctx.fillStyle = 'blue';
ctx.beginPath();
ctx.arc(50, 20, 5, 0, 2 * Math.PI);   // Start point
ctx.arc(50, 100, 5, 0, 2 * Math.PI);  // End point
ctx.fill();

// Control point
ctx.fillStyle = 'red';
ctx.beginPath();
ctx.arc(230, 30, 5, 0, 2 * Math.PI);
ctx.fill();
</pre>

<h4 id="Result">Result</h4>

<p>In this example, the <span style="color: red;">control point is red</span> and the <span style="color: blue;">start and end points are blue</span>.</p>

<p>{{ EmbedLiveSample('How_quadraticCurveTo_works', 315, 165) }}</p>

<h3 id="A_simple_quadratic_curve">A simple quadratic curve</h3>

<p>This example draws a simple quadratic Bézier curve using <code>quadraticCurveTo()</code>.</p>

<h4 id="HTML_2">HTML</h4>

<pre class="brush: html">&lt;canvas id="canvas"&gt;&lt;/canvas&gt;
</pre>

<h4 id="JavaScript_2">JavaScript</h4>

<p>The curve begins at the point specified by <code>moveTo()</code>: (20, 110). The control point is placed at (230, 150). The curve ends at (250, 20).</p>

<pre class="brush: js; highlight:[6]">const canvas = document.getElementById('canvas');
const ctx = canvas.getContext('2d');

ctx.beginPath();
ctx.moveTo(20, 110);
ctx.quadraticCurveTo(230, 150, 250, 20);
ctx.stroke();
</pre>

<h4 id="Result_2">Result</h4>

<p>{{ EmbedLiveSample('A_simple_quadratic_curve', 700, 180) }}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('HTML WHATWG', "scripting.html#dom-context-2d-quadraticcurveto", "CanvasRenderingContext2D.quadraticCurveTo")}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td> </td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.CanvasRenderingContext2D.quadraticCurveTo")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>The interface defining this method: {{domxref("CanvasRenderingContext2D")}}</li>
 <li><a href="http://en.wikipedia.org/wiki/B%C3%A9zier_curve">Wikipedia article on Bézier curves</a></li>
</ul>
